/* Tabela MAPACOMEXP*/
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela MAPACOMEXP */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela MAPACOMEXP, utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_EXP_MAPACOMEXP
AFTER DELETE OR INSERT OR UPDATE
ON MAPACOMEXP FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_GRAV_DESC    VARCHAR2(300);
  V_DESC         VARCHAR2(2000);
  V_LENGTH       FLOAT(10);
  V_CONT_LENGTH FLOAT(10);
  V_ITPESQ       VARCHAR2(80);
  V_NMOPERADOR   VARCHAR2(40);
  V_NRINCREST    VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
  V_CDFILLOGOPER VARCHAR2(4);

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   V_GRAV_DESC    := '';
   V_LENGTH       := '';
   V_CONT_LENGTH  := 1;
   V_DESC         := '';
   V_ITPESQ       := '';
   V_NMOPERADOR   := '';
   V_NRINCREST    := '';
   V_IDTIPOOPER   := '';
   V_CDFILLOGOPER := '';

   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

      IF INSERTING THEN

         IF :NEW.CDVENDEDOR IS NOT NULL THEN
            V_DESC := V_DESC || 'Vendedor = ' || NVL(:NEW.CDVENDEDOR,'') || ' ';
         END IF;
         IF :NEW.CDFILICOMIS IS NOT NULL THEN
            V_DESC := V_DESC || 'Filial = ' || NVL(:NEW.CDFILICOMIS,'') || ' ';
         END IF;
         IF :NEW.NRMAPACOMIS IS NOT NULL THEN
            V_DESC := V_DESC || 'Nmero do Mapa = ' || NVL(:NEW.NRMAPACOMIS,'') || ' ';
         END IF;
         IF :NEW.NRMAPACOMEXP IS NOT NULL THEN
            V_DESC := V_DESC || 'Nmero do Detalhe = ' || NVL(:NEW.NRMAPACOMEXP,'') || ' ';
         END IF;
         IF :NEW.CDFILIAL IS NOT NULL THEN
            V_DESC := V_DESC || 'Filial da NF = ' || NVL(:NEW.CDFILIAL,'') || ' ';
         END IF;         
         IF :NEW.NRLANCTONF IS NOT NULL THEN
            V_DESC := V_DESC || 'Lanamento da NF = ' || NVL(:NEW.NRLANCTONF,'') || ' ';
         END IF;
         IF :NEW.NREXPEDICAO IS NOT NULL THEN
            V_DESC := V_DESC || 'Expedio = ' || NVL(:NEW.NREXPEDICAO,'') || ' ';
         END IF;
         IF :NEW.VRNOTAFISC IS NOT NULL THEN
            V_DESC := V_DESC || 'Valor da NF = ' || NVL(:NEW.VRNOTAFISC,'') || ' ';
         END IF;
         IF :NEW.VRBASECOMIS IS NOT NULL THEN
            V_DESC := V_DESC || 'Valor Base para Comisso = ' || NVL(:NEW.VRBASECOMIS,'') || ' ';
         END IF;
         IF :NEW.VRCOMISSAO IS NOT NULL THEN
            V_DESC := V_DESC || 'Valor da Comisso = ' || NVL(:NEW.VRCOMISSAO,'') || ' ';
         END IF;
         IF :NEW.IDVRAPURADO IS NOT NULL THEN
            V_DESC := V_DESC || 'Apurado = ' || NVL(:NEW.IDVRAPURADO,'') || ' ';
         END IF;         

         V_ITPESQ     := :NEW.CDVENDEDOR || :NEW.CDFILICOMIS || :NEW.NRMAPACOMIS || :NEW.NRMAPACOMEXP;
         V_IDTIPOOPER := '1';

   ELSE

      IF UPDATING THEN

         IF :NEW.CDVENDEDOR IS NOT NULL THEN
            V_DESC := V_DESC || 'Vendedor = ' || NVL(:NEW.CDVENDEDOR,'') || ' ';
         END IF;
         IF :NEW.CDFILICOMIS IS NOT NULL THEN
            V_DESC := V_DESC || 'Filial = ' || NVL(:NEW.CDFILICOMIS,'') || ' ';
         END IF;
         IF :NEW.NRMAPACOMIS IS NOT NULL THEN
            V_DESC := V_DESC || 'Nmero do Mapa = ' || NVL(:NEW.NRMAPACOMIS,'') || ' ';
         END IF;
         IF :NEW.NRMAPACOMEXP IS NOT NULL THEN
            V_DESC := V_DESC || 'Nmero do Detalhe = ' || NVL(:NEW.NRMAPACOMEXP,'') || ' ';
         END IF;
         IF :NEW.CDFILIAL IS NOT NULL THEN
            V_DESC := V_DESC || 'Filial da NF = ' || NVL(:NEW.CDFILIAL,'') || ' ';
         END IF;         
         IF :NEW.NRLANCTONF IS NOT NULL THEN
            V_DESC := V_DESC || 'Lanamento da NF = ' || NVL(:NEW.NRLANCTONF,'') || ' ';
         END IF;
         IF :NEW.NREXPEDICAO IS NOT NULL THEN
            V_DESC := V_DESC || 'Expedio = ' || NVL(:NEW.NREXPEDICAO,'') || ' ';
         END IF;
         IF :NEW.VRNOTAFISC IS NOT NULL THEN
            V_DESC := V_DESC || 'Valor da NF = ' || NVL(:NEW.VRNOTAFISC,'') || ' ';
         END IF;
         IF :NEW.VRBASECOMIS IS NOT NULL THEN
            V_DESC := V_DESC || 'Valor Base para Comisso = ' || NVL(:NEW.VRBASECOMIS,'') || ' ';
         END IF;
         IF :NEW.VRCOMISSAO IS NOT NULL THEN
            V_DESC := V_DESC || 'Valor da Comisso = ' || NVL(:NEW.VRCOMISSAO,'') || ' ';
         END IF;
         IF :NEW.IDVRAPURADO IS NOT NULL THEN
            V_DESC := V_DESC || 'Apurado = ' || NVL(:NEW.IDVRAPURADO,'') || ' ';
         END IF;         

         V_ITPESQ     := :NEW.CDVENDEDOR || :NEW.CDFILICOMIS || :NEW.NRMAPACOMIS || :NEW.NRMAPACOMEXP;
         V_IDTIPOOPER := '2';

      END IF;

      IF DELETING  THEN

         IF :OLD.CDVENDEDOR IS NOT NULL THEN
            V_DESC := V_DESC || 'Vendedor = ' || NVL(:OLD.CDVENDEDOR,'') || ' ';
         END IF;
         IF :OLD.CDFILICOMIS IS NOT NULL THEN
            V_DESC := V_DESC || 'Filial = ' || NVL(:OLD.CDFILICOMIS,'') || ' ';
         END IF;
         IF :OLD.NRMAPACOMIS IS NOT NULL THEN
            V_DESC := V_DESC || 'Nmero do Mapa = ' || NVL(:OLD.NRMAPACOMIS,'') || ' ';
         END IF;
         IF :OLD.NRMAPACOMEXP IS NOT NULL THEN
            V_DESC := V_DESC || 'Nmero do Detalhe = ' || NVL(:OLD.NRMAPACOMEXP,'') || ' ';
         END IF;
         IF :OLD.CDFILIAL IS NOT NULL THEN
            V_DESC := V_DESC || 'Filial da NF = ' || NVL(:OLD.CDFILIAL,'') || ' ';
         END IF;         
         IF :OLD.NRLANCTONF IS NOT NULL THEN
            V_DESC := V_DESC || 'Lanamento da NF = ' || NVL(:OLD.NRLANCTONF,'') || ' ';
         END IF;
         IF :OLD.NREXPEDICAO IS NOT NULL THEN
            V_DESC := V_DESC || 'Expedio = ' || NVL(:OLD.NREXPEDICAO,'') || ' ';
         END IF;
         IF :OLD.VRNOTAFISC IS NOT NULL THEN
            V_DESC := V_DESC || 'Valor da NF = ' || NVL(:OLD.VRNOTAFISC,'') || ' ';
         END IF;
         IF :OLD.VRBASECOMIS IS NOT NULL THEN
            V_DESC := V_DESC || 'Valor Base para Comisso = ' || NVL(:OLD.VRBASECOMIS,'') || ' ';
         END IF;
         IF :OLD.VRCOMISSAO IS NOT NULL THEN
            V_DESC := V_DESC || 'Valor da Comisso = ' || NVL(:OLD.VRCOMISSAO,'') || ' ';
         END IF;
         IF :OLD.IDVRAPURADO IS NOT NULL THEN
            V_DESC := V_DESC || 'Apurado = ' || NVL(:OLD.IDVRAPURADO,'') || ' ';
         END IF;         

         V_ITPESQ     := :OLD.CDVENDEDOR || :OLD.CDFILICOMIS || :OLD.NRMAPACOMIS || :OLD.NRMAPACOMEXP;
         V_IDTIPOOPER := '3';

      END IF;
   END IF;

   IF NOT (V_DESC IS NULL) THEN

      V_LENGTH := LENGTH(V_DESC);

      WHILE V_LENGTH >= V_CONT_LENGTH LOOP

         V_GRAV_DESC := SUBSTR(V_DESC, V_CONT_LENGTH, 300);
         V_CONT_LENGTH := V_CONT_LENGTH + 300;

         INSERT INTO LOGOPERA ( NMTABELA,     DTOPERACAO,   NMRESPOPER,
                                IDTIPOOPER,   DSOPERACAO,   CDPESQITEM,
                                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                                DSMETUSUOPER, CDORESPOPER,  CDFILLOGOPER)
                       VALUES  ('MAPACOMEXP', SYSDATE,    NVL(V_NMOPERADOR,' '),
                                V_IDTIPOOPER,   V_GRAV_DESC,    V_ITPESQ,
                                V_DSSERVERRDM,  V_DSREMOTEADDR, V_DSREMOTEHOST,
                                V_DSSERVMETHOD, V_DSREMOTEOPER, V_CDFILLOGOPER);

      END LOOP;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_EXP_MAPACOMEXP','5.85.xxx'); END;
/