/* Sistemas Integrados TECNISA

Nome: 5036_FISTRGO.SQL

Descrio:
   Trigger para gravar o log das alteraes

Criao:
   22/06/2012 - Marcelo Alexsandro

Tabela DADOSFISCPROD: Dados Fiscais (por produto) da Regra Fiscal.
Descrio: A trigger insere registros na tabela LOGREGRAFISCAL a partir de alteraes na tabela DADOSFISCPROD
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_FIS_DADOSFISCPROD' AND
                 TYPE   = 'TR' 	           AND
	              U.UID  = O.UID             AND
	              U.NAME = USER)
DROP TRIGGER LOG_FIS_DADOSFISCPROD
GO

CREATE TRIGGER LOG_FIS_DADOSFISCPROD
ON DADOSFISCPROD
FOR INSERT, UPDATE, DELETE
AS
   DECLARE @V_USUARIO    VARCHAR(40);
   DECLARE @V_DTOPER     DATETIME;

   DECLARE @V_ID_COMANDO VARCHAR(1);
   DECLARE @V_DESC       VARCHAR(350);
   DECLARE @V_ITPESQ     VARCHAR(40);
   DECLARE @V_NMOPERADOR VARCHAR(40);
   DECLARE @V_IDTIPOOPER VARCHAR(1);

   DECLARE @V_CDREGRAFISC_OLD     VARCHAR(10);
   DECLARE @V_CDIMPOSTO_OLD       VARCHAR(2);
   DECLARE @V_CDPRODUTO_OLD       VARCHAR(10);
   DECLARE @V_CDSITUTRIB_OLD      VARCHAR(2);
   DECLARE @V_CDFISCAL_OLD        VARCHAR(1);
   DECLARE @V_CDPAISORIG_OLD      VARCHAR(4);
   DECLARE @V_SGESTAORIG_OLD      VARCHAR(2);
   DECLARE @V_CDMUNIORIG_OLD      VARCHAR(4);
   DECLARE @V_CDPAISDEST_OLD      VARCHAR(4);
   DECLARE @V_SGESTADEST_OLD      VARCHAR(2);
   DECLARE @V_CDMUNIDEST_OLD      VARCHAR(4);
   DECLARE @V_VRALIQUOTA_OLD      DOUBLE PRECISION;
   DECLARE @V_IDMODBCNFE_OLD      VARCHAR(1);
   DECLARE @V_IDMODBCSTNFE_OLD    VARCHAR(1);
   DECLARE @V_IDMOTIDESSTNFE_OLD  VARCHAR(1);
   DECLARE @V_CDTPCRPICOSTNFE_OLD VARCHAR(3);
   DECLARE @V_CDNATUBCPCSTNFE_OLD VARCHAR(2);
   DECLARE @V_VRINIFAIXA_OLD      DOUBLE PRECISION;
   DECLARE @V_VRFIMFAIXA_OLD      DOUBLE PRECISION;
   DECLARE @V_VRPARDEDUZ_OLD      DOUBLE PRECISION;
   DECLARE @V_VR1PERREDBC_OLD     DOUBLE PRECISION;
   DECLARE @V_VRPERREDBC_OLD      DOUBLE PRECISION;
   DECLARE @V_VRPBCSUBTRIB_OLD    DOUBLE PRECISION;
   DECLARE @V_IDTRATIMPST_OLD     VARCHAR(1);
   DECLARE @V_IDPMCBASECA_OLD     VARCHAR(1);
   DECLARE @V_IDCSTINTEREST_OLD   VARCHAR(1);
   DECLARE @V_IDCSTINTERNA_OLD    VARCHAR(1);
   DECLARE @V_NRSEQDADOSFISC_OLD  VARCHAR(10);
   DECLARE @V_CDNATUREC_OLD       VARCHAR(5);
   DECLARE @V_CDDETALHEFISC_OLD   VARCHAR(5);
   DECLARE @V_IDTIPODESTFISC_OLD  VARCHAR(1);
   DECLARE @V_IDTIPOORIGFISC_OLD  VARCHAR(1);

   DECLARE @V_CDREGRAFISC_NEW     VARCHAR(10);
   DECLARE @V_CDIMPOSTO_NEW       VARCHAR(2);
   DECLARE @V_CDPRODUTO_NEW       VARCHAR(10);
   DECLARE @V_CDSITUTRIB_NEW      VARCHAR(2);
   DECLARE @V_CDFISCAL_NEW        VARCHAR(1);
   DECLARE @V_CDPAISORIG_NEW      VARCHAR(4);
   DECLARE @V_SGESTAORIG_NEW      VARCHAR(2);
   DECLARE @V_CDMUNIORIG_NEW      VARCHAR(4);
   DECLARE @V_CDPAISDEST_NEW      VARCHAR(4);
   DECLARE @V_SGESTADEST_NEW      VARCHAR(2);
   DECLARE @V_CDMUNIDEST_NEW      VARCHAR(4);
   DECLARE @V_VRALIQUOTA_NEW      DOUBLE PRECISION;
   DECLARE @V_IDMODBCNFE_NEW      VARCHAR(1);
   DECLARE @V_IDMODBCSTNFE_NEW    VARCHAR(1);
   DECLARE @V_IDMOTIDESSTNFE_NEW  VARCHAR(1);
   DECLARE @V_CDTPCRPICOSTNFE_NEW VARCHAR(3);
   DECLARE @V_CDNATUBCPCSTNFE_NEW VARCHAR(2);
   DECLARE @V_VRINIFAIXA_NEW      DOUBLE PRECISION;
   DECLARE @V_VRFIMFAIXA_NEW      DOUBLE PRECISION;
   DECLARE @V_VRPARDEDUZ_NEW      DOUBLE PRECISION;
   DECLARE @V_VR1PERREDBC_NEW     DOUBLE PRECISION;
   DECLARE @V_VRPERREDBC_NEW      DOUBLE PRECISION;
   DECLARE @V_VRPBCSUBTRIB_NEW    DOUBLE PRECISION;
   DECLARE @V_IDTRATIMPST_NEW     VARCHAR(1);
   DECLARE @V_IDPMCBASECA_NEW     VARCHAR(1);
   DECLARE @V_IDCSTINTEREST_NEW   VARCHAR(1);
   DECLARE @V_IDCSTINTERNA_NEW    VARCHAR(1);
   DECLARE @V_NRSEQDADOSFISC_NEW  VARCHAR(10);
   DECLARE @V_CDNATUREC_NEW       VARCHAR(5);
   DECLARE @V_CDDETALHEFISC_NEW   VARCHAR(5);
   DECLARE @V_IDTIPODESTFISC_NEW  VARCHAR(1);
   DECLARE @V_IDTIPOORIGFISC_NEW  VARCHAR(1);
BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   SET @V_DESC       = '';
   SET @V_ITPESQ     = '';
   SET @V_NMOPERADOR = '';
   SET @V_IDTIPOOPER = '';

   EXEC NMUSUARIO @V_NMOPERADOR;
   SET @V_NMOPERADOR = ISNULL(@V_NMOPERADOR, '');

   DECLARE C_CURSOR CURSOR FOR
   SELECT
     'D' IDCOMANDO,
     DELETED.CDREGRAFISC,
     DELETED.CDIMPOSTO,
     DELETED.CDPRODUTO,
     DELETED.CDSITUTRIB,
     DELETED.CDFISCAL,
     DELETED.CDPAISORIG,
     DELETED.SGESTAORIG,
     DELETED.CDMUNIORIG,
     DELETED.CDPAISDEST,
     DELETED.SGESTADEST,
     DELETED.CDMUNIDEST,
     DELETED.VRALIQUOTA,
     DELETED.IDMODBCNFE,
     DELETED.IDMODBCSTNFE,
     DELETED.IDMOTIDESSTNFE,
     DELETED.CDTPCRPICOSTNFE,
     DELETED.CDNATUBCPCSTNFE,
     DELETED.VRINIFAIXA,
     DELETED.VRFIMFAIXA,
     DELETED.VRPARDEDUZ,
     DELETED.VR1PERREDBC,
     DELETED.VRPERREDBC,
     DELETED.VRPBCSUBTRIB,
     DELETED.IDTRATIMPST,
     DELETED.IDPMCBASECA,
     DELETED.IDCSTINTEREST,
     DELETED.IDCSTINTERNA,
     DELETED.NRSEQDADOSFISC,
     DELETED.CDNATUREC,
     DELETED.CDDETALHEFISC,
     DELETED.IDTIPODESTFISC,
     DELETED.IDTIPOORIGFISC,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL
   FROM
     DELETED
   WHERE CDREGRAFISC+CDIMPOSTO+CDPRODUTO+NRSEQDADOSFISC NOT IN (SELECT CDREGRAFISC+CDIMPOSTO+CDPRODUTO+NRSEQDADOSFISC FROM INSERTED)

   UNION ALL

   SELECT
     'U' IDCOMANDO,
     DELETED.CDREGRAFISC,
     DELETED.CDIMPOSTO,
     DELETED.CDPRODUTO,
     DELETED.CDSITUTRIB,
     DELETED.CDFISCAL,
     DELETED.CDPAISORIG,
     DELETED.SGESTAORIG,
     DELETED.CDMUNIORIG,
     DELETED.CDPAISDEST,
     DELETED.SGESTADEST,
     DELETED.CDMUNIDEST,
     DELETED.VRALIQUOTA,
     DELETED.IDMODBCNFE,
     DELETED.IDMODBCSTNFE,
     DELETED.IDMOTIDESSTNFE,
     DELETED.CDTPCRPICOSTNFE,
     DELETED.CDNATUBCPCSTNFE,
     DELETED.VRINIFAIXA,
     DELETED.VRFIMFAIXA,
     DELETED.VRPARDEDUZ,
     DELETED.VR1PERREDBC,
     DELETED.VRPERREDBC,
     DELETED.VRPBCSUBTRIB,
     DELETED.IDTRATIMPST,
     DELETED.IDPMCBASECA,
     DELETED.IDCSTINTEREST,
     DELETED.IDCSTINTERNA,
     DELETED.NRSEQDADOSFISC,
     DELETED.CDNATUREC,
     DELETED.CDDETALHEFISC,
     DELETED.IDTIPODESTFISC,
     DELETED.IDTIPOORIGFISC,
     INSERTED.CDREGRAFISC,
     INSERTED.CDIMPOSTO,
     INSERTED.CDPRODUTO,
     INSERTED.CDSITUTRIB,
     INSERTED.CDFISCAL,
     INSERTED.CDPAISORIG,
     INSERTED.SGESTAORIG,
     INSERTED.CDMUNIORIG,
     INSERTED.CDPAISDEST,
     INSERTED.SGESTADEST,
     INSERTED.CDMUNIDEST,
     INSERTED.VRALIQUOTA,
     INSERTED.IDMODBCNFE,
     INSERTED.IDMODBCSTNFE,
     INSERTED.IDMOTIDESSTNFE,
     INSERTED.CDTPCRPICOSTNFE,
     INSERTED.CDNATUBCPCSTNFE,
     INSERTED.VRINIFAIXA,
     INSERTED.VRFIMFAIXA,
     INSERTED.VRPARDEDUZ,
     INSERTED.VR1PERREDBC,
     INSERTED.VRPERREDBC,
     INSERTED.VRPBCSUBTRIB,
     INSERTED.IDTRATIMPST,
     INSERTED.IDPMCBASECA,
     INSERTED.IDCSTINTEREST,
     INSERTED.IDCSTINTERNA,
     INSERTED.NRSEQDADOSFISC,
     INSERTED.CDNATUREC,
     INSERTED.CDDETALHEFISC,
     INSERTED.IDTIPODESTFISC,
     INSERTED.IDTIPOORIGFISC
   FROM
      INSERTED,
      DELETED
   WHERE INSERTED.CDREGRAFISC    = DELETED.CDREGRAFISC
     AND INSERTED.CDIMPOSTO      = DELETED.CDIMPOSTO
     AND INSERTED.CDPRODUTO      = DELETED.CDPRODUTO
     AND INSERTED.NRSEQDADOSFISC = DELETED.NRSEQDADOSFISC

   UNION ALL

   SELECT
     'I' IDCOMANDO,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     NULL,
     INSERTED.CDREGRAFISC,
     INSERTED.CDIMPOSTO,
     INSERTED.CDPRODUTO,
     INSERTED.CDSITUTRIB,
     INSERTED.CDFISCAL,
     INSERTED.CDPAISORIG,
     INSERTED.SGESTAORIG,
     INSERTED.CDMUNIORIG,
     INSERTED.CDPAISDEST,
     INSERTED.SGESTADEST,
     INSERTED.CDMUNIDEST,
     INSERTED.VRALIQUOTA,
     INSERTED.IDMODBCNFE,
     INSERTED.IDMODBCSTNFE,
     INSERTED.IDMOTIDESSTNFE,
     INSERTED.CDTPCRPICOSTNFE,
     INSERTED.CDNATUBCPCSTNFE,
     INSERTED.VRINIFAIXA,
     INSERTED.VRFIMFAIXA,
     INSERTED.VRPARDEDUZ,
     INSERTED.VR1PERREDBC,
     INSERTED.VRPERREDBC,
     INSERTED.VRPBCSUBTRIB,
     INSERTED.IDTRATIMPST,
     INSERTED.IDPMCBASECA,
     INSERTED.IDCSTINTEREST,
     INSERTED.IDCSTINTERNA,
     INSERTED.NRSEQDADOSFISC,
     INSERTED.CDNATUREC,
     INSERTED.CDDETALHEFISC,
     INSERTED.IDTIPODESTFISC,
     INSERTED.IDTIPOORIGFISC
   FROM INSERTED
   WHERE CDREGRAFISC+CDIMPOSTO+CDPRODUTO+NRSEQDADOSFISC NOT IN (SELECT CDREGRAFISC+CDIMPOSTO+CDPRODUTO+NRSEQDADOSFISC FROM DELETED);
   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_CDREGRAFISC_OLD,
                                 @V_CDIMPOSTO_OLD,
                                 @V_CDPRODUTO_OLD,
                                 @V_CDSITUTRIB_OLD,
                                 @V_CDFISCAL_OLD,
                                 @V_CDPAISORIG_OLD,
                                 @V_SGESTAORIG_OLD,
                                 @V_CDMUNIORIG_OLD,
                                 @V_CDPAISDEST_OLD,
                                 @V_SGESTADEST_OLD,
                                 @V_CDMUNIDEST_OLD,
                                 @V_VRALIQUOTA_OLD,
                                 @V_IDMODBCNFE_OLD,
                                 @V_IDMODBCSTNFE_OLD,
                                 @V_IDMOTIDESSTNFE_OLD,
                                 @V_CDTPCRPICOSTNFE_OLD,
                                 @V_CDNATUBCPCSTNFE_OLD,
                                 @V_VRINIFAIXA_OLD,
                                 @V_VRFIMFAIXA_OLD,
                                 @V_VRPARDEDUZ_OLD,
                                 @V_VR1PERREDBC_OLD,
                                 @V_VRPERREDBC_OLD,
                                 @V_VRPBCSUBTRIB_OLD,
                                 @V_IDTRATIMPST_OLD,
                                 @V_IDPMCBASECA_OLD,
                                 @V_IDCSTINTEREST_OLD,
                                 @V_IDCSTINTERNA_OLD,
                                 @V_NRSEQDADOSFISC_OLD,
                                 @V_CDNATUREC_OLD,
                                 @V_CDDETALHEFISC_OLD,
                                 @V_IDTIPODESTFISC_OLD,
                                 @V_IDTIPOORIGFISC_OLD,
                                 @V_CDREGRAFISC_NEW,
                                 @V_CDIMPOSTO_NEW,
                                 @V_CDPRODUTO_NEW,
                                 @V_CDSITUTRIB_NEW,
                                 @V_CDFISCAL_NEW,
                                 @V_CDPAISORIG_NEW,
                                 @V_SGESTAORIG_NEW,
                                 @V_CDMUNIORIG_NEW,
                                 @V_CDPAISDEST_NEW,
                                 @V_SGESTADEST_NEW,
                                 @V_CDMUNIDEST_NEW,
                                 @V_VRALIQUOTA_NEW,
                                 @V_IDMODBCNFE_NEW,
                                 @V_IDMODBCSTNFE_NEW,
                                 @V_IDMOTIDESSTNFE_NEW,
                                 @V_CDTPCRPICOSTNFE_NEW,
                                 @V_CDNATUBCPCSTNFE_NEW,
                                 @V_VRINIFAIXA_NEW,
                                 @V_VRFIMFAIXA_NEW,
                                 @V_VRPARDEDUZ_NEW,
                                 @V_VR1PERREDBC_NEW,
                                 @V_VRPERREDBC_NEW,
                                 @V_VRPBCSUBTRIB_NEW,
                                 @V_IDTRATIMPST_NEW,
                                 @V_IDPMCBASECA_NEW,
                                 @V_IDCSTINTEREST_NEW,
                                 @V_IDCSTINTERNA_NEW,
                                 @V_NRSEQDADOSFISC_NEW,
                                 @V_CDNATUREC_NEW,
                                 @V_CDDETALHEFISC_NEW,
                                 @V_IDTIPODESTFISC_NEW,
                                 @V_IDTIPOORIGFISC_NEW;
   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_ID_COMANDO = 'U' BEGIN
         IF @V_CDSITUTRIB_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'CST = '                 + @V_CDSITUTRIB_NEW         +' ';
         END;
         IF @V_CDFISCAL_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Cod. Fiscal = '         + @V_CDFISCAL_NEW           +' ';
         END;
         IF @V_IDTIPOORIGFISC_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC +  'Tipo Origem = '       + @V_IDTIPOORIGFISC_NEW     +' ';
         END;
         IF @V_CDPAISORIG_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC +  'Pais Origem = '        + @V_CDPAISORIG_NEW         +' ';
         END;
         IF @V_SGESTAORIG_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC +  'UF   Origem = '        + @V_SGESTAORIG_NEW         +' ';
         END;
         IF @V_CDMUNIORIG_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC +  'Municipio Orig. = '    + @V_CDMUNIORIG_NEW         +' ';
         END;
         IF @V_IDTIPODESTFISC_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC +  'Tipo Destino = '       + @V_IDTIPODESTFISC_NEW     +' ';
         END;
         IF @V_CDPAISDEST_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC +  'Pais Destino = '       + @V_CDPAISDEST_NEW         +' ';
         END;
         IF @V_SGESTADEST_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC +  'UF   Destino = '       + @V_SGESTADEST_NEW         +' ';
         END;
         IF @V_CDMUNIDEST_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC +  'Municipio Dest. = '    + @V_CDMUNIDEST_NEW         +' ';
         END;
         IF @V_VRALIQUOTA_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC +  'Aliquota = '           + CONVERT(VARCHAR, @V_VRALIQUOTA_NEW)         +' ';
         END;
         IF @V_IDMODBCNFE_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC +  'BC ICMS = '            + @V_IDMODBCNFE_NEW         +' ';
         END;
         IF @V_IDMODBCSTNFE_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC +  'BC ICMS ST = '         + @V_IDMODBCSTNFE_NEW       +' ';
         END;
         IF @V_IDMOTIDESSTNFE_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC +  'Motivo Desoneracao = ' + @V_IDMOTIDESSTNFE_NEW     +' ';
         END;
         IF @V_CDTPCRPICOSTNFE_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC +  'Tipo de Credito = '    + @V_CDTPCRPICOSTNFE_NEW    +' ';
         END;
         IF @V_CDNATUBCPCSTNFE_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC +  'Natureza BC = '        + @V_CDNATUBCPCSTNFE_NEW    +' ';
         END;
         IF @V_VRINIFAIXA_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC +  'Faixa Inicial = '      + CONVERT(VARCHAR,@V_VRINIFAIXA_NEW)         +' ';
         END;
         IF @V_VRFIMFAIXA_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC +  'Faixa Final = '        + CONVERT(VARCHAR,@V_VRFIMFAIXA_NEW)         +' ';
         END;
         IF @V_VRPARDEDUZ_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC +  'Parcela a Deduzir = '  + CONVERT(VARCHAR,@V_VRPARDEDUZ_NEW)         +' ';
         END;
         IF @V_VR1PERREDBC_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC +  '1 Red. BC = '         + CONVERT(VARCHAR,@V_VR1PERREDBC_NEW)        +' ';
         END;
         IF @V_VRPERREDBC_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC +  'Red. BC = '            + CONVERT(VARCHAR,@V_VRPERREDBC_NEW)         +' ';
         END;
         IF @V_VRPBCSUBTRIB_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC +  'Majoracao ST = '       + CONVERT(VARCHAR,@V_VRPBCSUBTRIB_NEW)       +' ';
         END;
         IF @V_IDTRATIMPST_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC +  'Tratamento Doc. = '    + @V_IDTRATIMPST_NEW        +' ';
         END;
         IF @V_IDPMCBASECA_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC +  'PMC = '                + @V_IDPMCBASECA_NEW        +' ';
         END;
         IF @V_IDCSTINTEREST_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC +  'Interestadual = '      + @V_IDCSTINTEREST_NEW      +' ';
         END;
         IF @V_IDCSTINTERNA_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC +  'Internacional = '      + @V_IDCSTINTERNA_NEW       +' ';
         END;
         IF @V_CDNATUREC_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC +  'Natureza Receita = '   + @V_CDNATUREC_NEW          +' ';
         END;
         IF @V_CDDETALHEFISC_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC +  'Detalhamento = '       + @V_CDDETALHEFISC_NEW;
         END;
         SET @V_ITPESQ = @V_CDREGRAFISC_NEW+@V_CDIMPOSTO_NEW+@V_CDPRODUTO_NEW+CONVERT(VARCHAR, @V_NRSEQDADOSFISC_NEW);
         SET @V_IDTIPOOPER = '2';
      END
      ELSE BEGIN
         IF @V_ID_COMANDO = 'I' BEGIN
            IF @V_CDSITUTRIB_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'CST = '                 + @V_CDSITUTRIB_NEW         +' ';
            END;
            IF @V_CDFISCAL_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Cod. Fiscal = '         + @V_CDFISCAL_NEW           +' ';
            END;
            IF @V_IDTIPOORIGFISC_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC +  'Tipo Origem = '       + @V_IDTIPOORIGFISC_NEW     +' ';
            END;
            IF @V_CDPAISORIG_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC +  'Pais Origem = '        + @V_CDPAISORIG_NEW         +' ';
            END;
            IF @V_SGESTAORIG_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC +  'UF   Origem = '        + @V_SGESTAORIG_NEW         +' ';
            END;
            IF @V_CDMUNIORIG_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC +  'Municipio Orig. = '    + @V_CDMUNIORIG_NEW         +' ';
            END;
            IF @V_IDTIPODESTFISC_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC +  'Tipo Destino = '       + @V_IDTIPODESTFISC_NEW     +' ';
            END;
            IF @V_CDPAISDEST_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC +  'Pais Destino = '       + @V_CDPAISDEST_NEW         +' ';
            END;
            IF @V_SGESTADEST_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC +  'UF   Destino = '       + @V_SGESTADEST_NEW         +' ';
            END;
            IF @V_CDMUNIDEST_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC +  'Municipio Dest. = '    + @V_CDMUNIDEST_NEW         +' ';
            END;
            IF @V_VRALIQUOTA_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC +  'Aliquota = '           + CONVERT(VARCHAR,@V_VRALIQUOTA_NEW)         +' ';
            END;
            IF @V_IDMODBCNFE_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC +  'BC ICMS = '            + @V_IDMODBCNFE_NEW         +' ';
            END;
            IF @V_IDMODBCSTNFE_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC +  'BC ICMS ST = '         + @V_IDMODBCSTNFE_NEW       +' ';
            END;
            IF @V_IDMOTIDESSTNFE_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC +  'Motivo Desoneracao = ' + @V_IDMOTIDESSTNFE_NEW     +' ';
            END;
            IF @V_CDTPCRPICOSTNFE_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC +  'Tipo de Credito = '    + @V_CDTPCRPICOSTNFE_NEW    +' ';
            END;
            IF @V_CDNATUBCPCSTNFE_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC +  'Natureza BC = '        + @V_CDNATUBCPCSTNFE_NEW    +' ';
            END;
            IF @V_VRINIFAIXA_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC +  'Faixa Inicial = '      + CONVERT(VARCHAR,@V_VRINIFAIXA_NEW)         +' ';
            END;
            IF @V_VRFIMFAIXA_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC +  'Faixa Final = '        + CONVERT(VARCHAR,@V_VRFIMFAIXA_NEW)         +' ';
            END;
            IF @V_VRPARDEDUZ_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC +  'Parcela a Deduzir = '  + CONVERT(VARCHAR,@V_VRPARDEDUZ_NEW)         +' ';
            END;
            IF @V_VR1PERREDBC_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC +  '1 Red. BC = '         + CONVERT(VARCHAR,@V_VR1PERREDBC_NEW)        +' ';
            END;
            IF @V_VRPERREDBC_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC +  'Red. BC = '            + CONVERT(VARCHAR,@V_VRPERREDBC_NEW)         +' ';
            END;
            IF @V_VRPBCSUBTRIB_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC +  'Majoracao ST = '       + CONVERT(VARCHAR,@V_VRPBCSUBTRIB_NEW)       +' ';
            END;
            IF @V_IDTRATIMPST_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC +  'Tratamento Doc. = '    + @V_IDTRATIMPST_NEW        +' ';
            END;
            IF @V_IDPMCBASECA_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC +  'PMC = '                + @V_IDPMCBASECA_NEW        +' ';
            END;
            IF @V_IDCSTINTEREST_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC +  'Interestadual = '      + @V_IDCSTINTEREST_NEW      +' ';
            END;
            IF @V_IDCSTINTERNA_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC +  'Internacional = '      + @V_IDCSTINTERNA_NEW       +' ';
            END;
            IF @V_CDNATUREC_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC +  'Natureza Receita = '   + @V_CDNATUREC_NEW          +' ';
            END;
            IF @V_CDDETALHEFISC_NEW IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC +  'Detalhamento = '       + @V_CDDETALHEFISC_NEW;
            END;
            SET @V_ITPESQ = @V_CDREGRAFISC_NEW+@V_CDIMPOSTO_NEW+@V_CDPRODUTO_NEW+CONVERT(VARCHAR, @V_NRSEQDADOSFISC_NEW);
            SET @V_IDTIPOOPER = '1';
         END
         ELSE BEGIN
            IF @V_ID_COMANDO = 'D' BEGIN
               IF @V_CDSITUTRIB_OLD IS NOT NULL BEGIN
                  SET @V_DESC = @V_DESC + 'CST = '                 + @V_CDSITUTRIB_OLD         +' ';
               END;
               IF @V_CDFISCAL_OLD IS NOT NULL BEGIN
                  SET @V_DESC = @V_DESC + 'Cod. Fiscal = '         + @V_CDFISCAL_OLD           +' ';
               END;
               IF @V_IDTIPOORIGFISC_OLD IS NOT NULL BEGIN
                  SET @V_DESC = @V_DESC +  'Tipo Origem = '       + @V_IDTIPOORIGFISC_OLD     +' ';
               END;
               IF @V_CDPAISORIG_OLD IS NOT NULL BEGIN
                  SET @V_DESC = @V_DESC +  'Pais Origem = '        + @V_CDPAISORIG_OLD         +' ';
               END;
               IF @V_SGESTAORIG_OLD IS NOT NULL BEGIN
                  SET @V_DESC = @V_DESC +  'UF   Origem = '        + @V_SGESTAORIG_OLD         +' ';
               END;
               IF @V_CDMUNIORIG_OLD IS NOT NULL BEGIN
                  SET @V_DESC = @V_DESC +  'Municipio Orig. = '    + @V_CDMUNIORIG_OLD         +' ';
               END;
               IF @V_IDTIPODESTFISC_OLD IS NOT NULL BEGIN
                  SET @V_DESC = @V_DESC +  'Tipo Destino = '       + @V_IDTIPODESTFISC_OLD     +' ';
               END;
               IF @V_CDPAISDEST_OLD IS NOT NULL BEGIN
                  SET @V_DESC = @V_DESC +  'Pais Destino = '       + @V_CDPAISDEST_OLD         +' ';
               END;
               IF @V_SGESTADEST_OLD IS NOT NULL BEGIN
                  SET @V_DESC = @V_DESC +  'UF   Destino = '       + @V_SGESTADEST_OLD         +' ';
               END;
               IF @V_CDMUNIDEST_OLD IS NOT NULL BEGIN
                  SET @V_DESC = @V_DESC +  'Municipio Dest. = '    + @V_CDMUNIDEST_OLD         +' ';
               END;
               IF @V_VRALIQUOTA_OLD IS NOT NULL BEGIN
                  SET @V_DESC = @V_DESC +  'Aliquota = '           + CONVERT(VARCHAR,@V_VRALIQUOTA_OLD)         +' ';
               END;
               IF @V_IDMODBCNFE_OLD IS NOT NULL BEGIN
                  SET @V_DESC = @V_DESC +  'BC ICMS = '            + @V_IDMODBCNFE_OLD         +' ';
               END;
               IF @V_IDMODBCSTNFE_OLD IS NOT NULL BEGIN
                  SET @V_DESC = @V_DESC +  'BC ICMS ST = '         + @V_IDMODBCSTNFE_OLD       +' ';
               END;
               IF @V_IDMOTIDESSTNFE_OLD IS NOT NULL BEGIN
                  SET @V_DESC = @V_DESC +  'Motivo Desoneracao = ' + @V_IDMOTIDESSTNFE_OLD     +' ';
               END;
               IF @V_CDTPCRPICOSTNFE_OLD IS NOT NULL BEGIN
                  SET @V_DESC = @V_DESC +  'Tipo de Credito = '    + @V_CDTPCRPICOSTNFE_OLD    +' ';
               END;
               IF @V_CDNATUBCPCSTNFE_OLD IS NOT NULL BEGIN
                  SET @V_DESC = @V_DESC +  'Natureza BC = '        + @V_CDNATUBCPCSTNFE_OLD    +' ';
               END;
               IF @V_VRINIFAIXA_OLD IS NOT NULL BEGIN
                  SET @V_DESC = @V_DESC +  'Faixa Inicial = '      + CONVERT(VARCHAR,@V_VRINIFAIXA_OLD)         +' ';
               END;
               IF @V_VRFIMFAIXA_OLD IS NOT NULL BEGIN
                  SET @V_DESC = @V_DESC +  'Faixa Final = '        + CONVERT(VARCHAR,@V_VRFIMFAIXA_OLD)         +' ';
               END;
               IF @V_VRPARDEDUZ_OLD IS NOT NULL BEGIN
                  SET @V_DESC = @V_DESC +  'Parcela a Deduzir = '  + CONVERT(VARCHAR,@V_VRPARDEDUZ_OLD)         +' ';
               END;
               IF @V_VR1PERREDBC_OLD IS NOT NULL BEGIN
                  SET @V_DESC = @V_DESC +  '1 Red. BC = '         + CONVERT(VARCHAR,@V_VR1PERREDBC_OLD)        +' ';
               END;
               IF @V_VRPERREDBC_OLD IS NOT NULL BEGIN
                  SET @V_DESC = @V_DESC +  'Red. BC = '            + CONVERT(VARCHAR,@V_VRPERREDBC_OLD)         +' ';
               END;
               IF @V_VRPBCSUBTRIB_OLD IS NOT NULL BEGIN
                  SET @V_DESC = @V_DESC +  'Majoracao ST = '       + CONVERT(VARCHAR,@V_VRPBCSUBTRIB_OLD)       +' ';
               END;
               IF @V_IDTRATIMPST_OLD IS NOT NULL BEGIN
                  SET @V_DESC = @V_DESC +  'Tratamento Doc. = '    + @V_IDTRATIMPST_OLD        +' ';
               END;
               IF @V_IDPMCBASECA_OLD IS NOT NULL BEGIN
                  SET @V_DESC = @V_DESC +  'PMC = '                + @V_IDPMCBASECA_OLD        +' ';
               END;
               IF @V_IDCSTINTEREST_OLD IS NOT NULL BEGIN
                  SET @V_DESC = @V_DESC +  'Interestadual = '      + @V_IDCSTINTEREST_OLD      +' ';
               END;
               IF @V_IDCSTINTERNA_OLD IS NOT NULL BEGIN
                  SET @V_DESC = @V_DESC +  'Internacional = '      + @V_IDCSTINTERNA_OLD       +' ';
               END;
               IF @V_CDNATUREC_OLD IS NOT NULL BEGIN
                  SET @V_DESC = @V_DESC +  'Natureza Receita = '   + @V_CDNATUREC_OLD          +' ';
               END;
               IF @V_CDDETALHEFISC_OLD IS NOT NULL BEGIN
                  SET @V_DESC = @V_DESC +  'Detalhamento = '       + @V_CDDETALHEFISC_OLD;
               END;
               SET @V_ITPESQ = @V_CDREGRAFISC_OLD+@V_CDIMPOSTO_OLD+@V_CDPRODUTO_OLD+CONVERT(VARCHAR, @V_NRSEQDADOSFISC_OLD);
               SET @V_IDTIPOOPER = '3';
            END;
         END;
      END;
      INSERT INTO LOGREGRAFISCAL
         (NMTABELA,
          DTOPERACAO,
          NMRESPOPER,
          IDTIPOOPER,
          DSOPERACAO,
          CDPESQITEM)
       VALUES
         ('DADOSFISCPROD',
          GETDATE(),
          ISNULL(@V_NMOPERADOR,' '),
          @V_IDTIPOOPER,
          @V_DESC,
          @V_ITPESQ);
      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                    @V_CDREGRAFISC_OLD,
                                    @V_CDIMPOSTO_OLD,
                                    @V_CDPRODUTO_OLD,
                                    @V_CDSITUTRIB_OLD,
                                    @V_CDFISCAL_OLD,
                                    @V_CDPAISORIG_OLD,
                                    @V_SGESTAORIG_OLD,
                                    @V_CDMUNIORIG_OLD,
                                    @V_CDPAISDEST_OLD,
                                    @V_SGESTADEST_OLD,
                                    @V_CDMUNIDEST_OLD,
                                    @V_VRALIQUOTA_OLD,
                                    @V_IDMODBCNFE_OLD,
                                    @V_IDMODBCSTNFE_OLD,
                                    @V_IDMOTIDESSTNFE_OLD,
                                    @V_CDTPCRPICOSTNFE_OLD,
                                    @V_CDNATUBCPCSTNFE_OLD,
                                    @V_VRINIFAIXA_OLD,
                                    @V_VRFIMFAIXA_OLD,
                                    @V_VRPARDEDUZ_OLD,
                                    @V_VR1PERREDBC_OLD,
                                    @V_VRPERREDBC_OLD,
                                    @V_VRPBCSUBTRIB_OLD,
                                    @V_IDTRATIMPST_OLD,
                                    @V_IDPMCBASECA_OLD,
                                    @V_IDCSTINTEREST_OLD,
                                    @V_IDCSTINTERNA_OLD,
                                    @V_NRSEQDADOSFISC_OLD,
                                    @V_CDNATUREC_OLD,
                                    @V_CDDETALHEFISC_OLD,
                                    @V_IDTIPODESTFISC_OLD,
                                    @V_IDTIPOORIGFISC_OLD,
                                    @V_CDREGRAFISC_NEW,
                                    @V_CDIMPOSTO_NEW,
                                    @V_CDPRODUTO_NEW,
                                    @V_CDSITUTRIB_NEW,
                                    @V_CDFISCAL_NEW,
                                    @V_CDPAISORIG_NEW,
                                    @V_SGESTAORIG_NEW,
                                    @V_CDMUNIORIG_NEW,
                                    @V_CDPAISDEST_NEW,
                                    @V_SGESTADEST_NEW,
                                    @V_CDMUNIDEST_NEW,
                                    @V_VRALIQUOTA_NEW,
                                    @V_IDMODBCNFE_NEW,
                                    @V_IDMODBCSTNFE_NEW,
                                    @V_IDMOTIDESSTNFE_NEW,
                                    @V_CDTPCRPICOSTNFE_NEW,
                                    @V_CDNATUBCPCSTNFE_NEW,
                                    @V_VRINIFAIXA_NEW,
                                    @V_VRFIMFAIXA_NEW,
                                    @V_VRPARDEDUZ_NEW,
                                    @V_VR1PERREDBC_NEW,
                                    @V_VRPERREDBC_NEW,
                                    @V_VRPBCSUBTRIB_NEW,
                                    @V_IDTRATIMPST_NEW,
                                    @V_IDPMCBASECA_NEW,
                                    @V_IDCSTINTEREST_NEW,
                                    @V_IDCSTINTERNA_NEW,
                                    @V_NRSEQDADOSFISC_NEW,
                                    @V_CDNATUREC_NEW,
                                    @V_CDDETALHEFISC_NEW,
                                    @V_IDTIPODESTFISC_NEW,
                                    @V_IDTIPOORIGFISC_NEW;

   END;
   CLOSE C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_FIS_DADOSFISCPROD','5.30.xxx';
GO
